char bd_help[]="\
The depthmap builder is a powerful tool allowing to build a depthmap\n\
by assigning to each point of coordinates (x,y) in a rectangle \n\
x1 <= x <= x2, y1 <= y <= y2, a luminosity value in the rangle 0..255.\n\
The width and height in pixels of the desired resulting image should\n\
be specified in the relevant entries.\n\
\n\
The luminosity is calculated mathematically as a result of the position \n\
of all objects present in the scene, and depends linearly on the value \n\
of the third coordinate z, which is viewed as perpendicular to the Oxy \n\
screen plane. The user should thus also specify the lower and upper \n\
values of z. If several objects have parts sharing the same values of\n\
(x,y), only those parts corresponding to the upper layer (z maximal)\n\
are represented. \n\
\n\
The user should enter a C procedure defining the objects to be built,\n\
as for the provided examples in the mathfiles/ directory. This\n\
procedure is then embedded in suitable C code to produce a .pgm file\n\
(portable gray bitmap). The pnmtotiff utility is finally used to\n\
convert this image into the tif format required by SIS. As a\n\
consequence, the depthmap builder will only work if you have \n\
pnmtotiff or a similar utility installed on your system.\n\
\n\
Several position and drawing primitives can be used, in any combination\n\
position primitives -- drawing primitives, \n\
position primitives -- drawing primitives,\n\
position primitives -- drawing primitives...\n\
\n\
\n\
Position primitives:\n\
\n\
1. rotation_angles(double a, double b, double c);\n\
\n\
Rotates an object by an angle a with respect to 0xy, b with respect to\n\
0xz and c with respect to 0yz. All angles in degrees.\n\
Default values: a=0, b=0, c=0.\n\
\n\
2. scale(double h);\n\
Sets an homothety factor equal to h. All three coordinates x,y,z are \n\
multiplied by h.\n\
Default value: h=1.\n\
\n\
3. translation(double a, double b, double c);\n\
\n\
Translates coordinates (x,y,z) by (a,b,c).\n\
Default values: (a,b,c)=(0,0,0).\n\
\n\
\n\
Drawing primitives:\n\
\n\
0. max(double x, double y);  min(double x, double y);\n\
\n\
standard max and min functions.\n\
\n\
1. mesh(point *p, int i, int j, int k);\n\
\n\
Here \"point\" is the predefined type  double[3], and p is an\n\
array of points, e.g.  point p[15], representing 15 points\n\
as triples of coordinates (x,y,z). The above mesh primitive \n\
draws the 3D-triangle whose vertices are p[i], p[j], p[k].\n\
\n\
2. build(BFunction bfunct);\n\
\n\
where BFunction is the predefined void function type\n\
typedef void (*BFunction)();\n\
\n\
bfunct() is used to define the object, e.g. as a collection of \n\
triangular meshes, and build(bfunct) makes the actual drawing.\n\
\n\
3. graph(PFunction pfunct, double u1, double u2, int nu,\n\
                           double v1, double v2, int nv);\n\
\n\
where PFunction is the predefined function type\n\
typedef void  (*PFunction)(point p, double u, double v);\n\
\n\
pfunct(p,u,v) assigns to parameters (u,v) a point\n\
       p={x(u,v),y(u,v),z(u,v)}. \n\
The procedure  graph(pfunct, u1,u2,nu, v1,v2,nv); draws the \n\
graph for u1 <= u <= u2, v1 <= v <= v2, by using a subdvision\n\
in nu subintervals for u and nv subintervals for v.\n\
\n\
4. light(ZFunction zfunct);\n\
\n\
with predefined function type\n\
typedef double (*ZFunction)(double x, double y);\n\
\n\
The function zfunct prescribes the depth as  z=zfunct(x,y), and\n\
light(zfunct) assigns the luminosity accordingly. \n\
NOTE: The position primitives have no effect on the light procedure.\n\
\n\
\n\
Check examples in the /mathfiles directory to see how all this works.\n\
";
